From 8d7bf8b1089786a6c2e9fc81d00caf1e4b317816 Mon Sep 17 00:00:00 2001
From: Mariam Elshakfy <mariam.elshakfy@linaro.org>
Date: Thu, 31 Oct 2024 16:38:52 +0000
Subject: [PATCH] EmbeddedPkg/Universal/MmcDxe: Send CMD12 before CMD13 for
 multi-block CMDs

This change moves multi-block stop transmission scenario
before issuing CMD13, as CMD13 gets stuck due to the DAT
line being unavailable during these operations.

Upstream-Status: Pending
Signed-off-by: Mariam Elshakfy <mariam.elshakfy@linaro.org>
---
 EmbeddedPkg/Universal/MmcDxe/MmcBlockIo.c | 13 ++++---------
 1 file changed, 4 insertions(+), 9 deletions(-)

diff --git a/EmbeddedPkg/Universal/MmcDxe/MmcBlockIo.c b/EmbeddedPkg/Universal/MmcDxe/MmcBlockIo.c
index d695e25571..95d0ddfcc9 100644
--- a/EmbeddedPkg/Universal/MmcDxe/MmcBlockIo.c
+++ b/EmbeddedPkg/Universal/MmcDxe/MmcBlockIo.c
@@ -195,6 +195,10 @@ MmcTransferBlock (
     }
   }
 
+  if (BufferSize > This->Media->BlockSize) {
+    Status = MmcStopTransmission (MmcHost);
+  }
+
   // Command 13 - Read status and wait for programming to complete (return to tran)
   Timeout     = MMCI0_TIMEOUT;
   CmdArg      = MmcHostInstance->CardInfo.RCA << 16;
@@ -212,15 +216,6 @@ MmcTransferBlock (
     }
   }
 
-  if (BufferSize > This->Media->BlockSize) {
-    Status = MmcHost->SendCommand (MmcHost, MMC_CMD12, 0);
-    if (EFI_ERROR (Status)) {
-      DEBUG ((DEBUG_BLKIO, "%a(): Error and Status:%r\n", __func__, Status));
-    }
-
-    MmcHost->ReceiveResponse (MmcHost, MMC_RESPONSE_TYPE_R1b, Response);
-  }
-
   Status = MmcNotifyState (MmcHostInstance, MmcTransferState);
   if (EFI_ERROR (Status)) {
     DEBUG ((DEBUG_ERROR, "MmcIoBlocks() : Error MmcTransferState\n"));
-- 
2.34.1

